Index: /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/ProblemInstancesModel.edmx
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/ProblemInstancesModel.edmx	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/ProblemInstancesModel.edmx	(revision 6733)
@@ -5,5 +5,5 @@
     <!-- SSDL content -->
     <edmx:StorageModels>
-      <Schema Namespace="ProblemInstancesModel.Store" Alias="Self" Provider="System.Data.SqlClient" ProviderManifestToken="2008" xmlns:store="http://schemas.microsoft.com/ado/2007/12/edm/EntityStoreSchemaGenerator" xmlns="http://schemas.microsoft.com/ado/2009/02/edm/ssdl">
+    <Schema Namespace="ProblemInstancesModel.Store" Alias="Self" Provider="System.Data.SqlClient" ProviderManifestToken="2008" xmlns:store="http://schemas.microsoft.com/ado/2007/12/edm/EntityStoreSchemaGenerator" xmlns="http://schemas.microsoft.com/ado/2009/02/edm/ssdl">
         <EntityContainer Name="ProblemInstancesModelStoreContainer">
           <EntitySet Name="QAPInstance" EntityType="ProblemInstancesModel.Store.QAPInstance" store:Type="Tables" Schema="dbo" />
@@ -16,24 +16,24 @@
         <EntityType Name="QAPInstance">
           <Key>
-            <PropertyRef Name="name" />
+            <PropertyRef Name="Name" />
           </Key>
-          <Property Name="name" Type="nvarchar" Nullable="false" MaxLength="64" />
-          <Property Name="description" Type="ntext" />
-          <Property Name="maximization" Type="bit" Nullable="false" />
-          <Property Name="weights" Type="text" Nullable="false" />
-          <Property Name="weights_sha1" Type="char" Nullable="false" MaxLength="40" />
-          <Property Name="distances" Type="text" Nullable="false" />
-          <Property Name="distances_sha1" Type="char" Nullable="false" MaxLength="40" />
-          <Property Name="problemsize" Type="int" Nullable="false" />
+          <Property Name="Name" Type="nvarchar" Nullable="false" MaxLength="64" />
+          <Property Name="Description" Type="ntext" />
+          <Property Name="Maximization" Type="bit" Nullable="false" />
+          <Property Name="Weights" Type="varchar(max)" Nullable="false" />
+          <Property Name="WeightsHash" Type="char" Nullable="false" MaxLength="40" />
+          <Property Name="Distances" Type="varchar(max)" Nullable="false" />
+          <Property Name="DistancesHash" Type="char" Nullable="false" MaxLength="40" />
+          <Property Name="ProblemSize" Type="int" Nullable="false" />
         </EntityType>
         <EntityType Name="QAPSolution">
           <Key>
-            <PropertyRef Name="id" />
+            <PropertyRef Name="Id" />
           </Key>
-          <Property Name="id" Type="int" Nullable="false" StoreGeneratedPattern="Identity" />
-          <Property Name="name" Type="nvarchar" Nullable="false" MaxLength="64" />
-          <Property Name="assignment" Type="text" Nullable="false" />
-          <Property Name="assignment_sha1" Type="char" Nullable="false" MaxLength="40" />
-          <Property Name="quality" Type="float" Nullable="false" />
+          <Property Name="Id" Type="int" Nullable="false" StoreGeneratedPattern="Identity" />
+          <Property Name="Name" Type="nvarchar" Nullable="false" MaxLength="64" />
+          <Property Name="Assignment" Type="text" />
+          <Property Name="AssignmentHash" Type="char" MaxLength="40" />
+          <Property Name="Quality" Type="float" Nullable="false" />
         </EntityType>
         <Association Name="FK_QAPSolution_QAPInstance">
@@ -44,13 +44,12 @@
           <ReferentialConstraint>
             <Principal Role="QAPInstance">
-              <PropertyRef Name="name" />
+              <PropertyRef Name="Name" />
             </Principal>
             <Dependent Role="QAPSolution">
-              <PropertyRef Name="name" />
+              <PropertyRef Name="Name" />
             </Dependent>
           </ReferentialConstraint>
         </Association>
-      </Schema>
-    </edmx:StorageModels>
+      </Schema></edmx:StorageModels>
     <!-- CSDL content -->
     <edmx:ConceptualModels>
@@ -59,5 +58,5 @@
           <EntitySet Name="QAPInstances" EntityType="ProblemInstancesModel.QAPInstance" />
           <EntitySet Name="QAPSolutions" EntityType="ProblemInstancesModel.QAPSolution" />
-          <AssociationSet Name="FK_QAPSolution_QAPInstance" Association="ProblemInstancesModel.FK_QAPSolution_QAPInstance">
+          <AssociationSet Name="FK_QAPSolution_QAPInstance1" Association="ProblemInstancesModel.FK_QAPSolution_QAPInstance1">
             <End Role="QAPInstance" EntitySet="QAPInstances" />
             <End Role="QAPSolution" EntitySet="QAPSolutions" />
@@ -66,38 +65,36 @@
         <EntityType Name="QAPInstance">
           <Key>
-            <PropertyRef Name="name" />
+            <PropertyRef Name="Name" />
           </Key>
-          <Property Name="name" Type="String" Nullable="false" MaxLength="64" Unicode="true" FixedLength="false" />
-          <Property Name="description" Type="String" MaxLength="Max" Unicode="true" FixedLength="false" />
-          <Property Name="maximization" Type="Boolean" Nullable="false" />
-          <Property Name="weights" Type="String" Nullable="false" MaxLength="Max" Unicode="false" FixedLength="false" />
-          <Property Name="weights_sha1" Type="String" Nullable="false" MaxLength="40" Unicode="false" FixedLength="true" />
-          <Property Name="distances" Type="String" Nullable="false" MaxLength="Max" Unicode="false" FixedLength="false" />
-          <Property Name="distances_sha1" Type="String" Nullable="false" MaxLength="40" Unicode="false" FixedLength="true" />
-          <Property Name="problemsize" Type="Int32" Nullable="false" />
-          <NavigationProperty Name="QAPSolutions" Relationship="ProblemInstancesModel.FK_QAPSolution_QAPInstance" FromRole="QAPInstance" ToRole="QAPSolution" />
+          <Property Type="String" Name="Name" Nullable="false" MaxLength="64" FixedLength="false" Unicode="true" />
+          <Property Type="String" Name="Description" MaxLength="Max" FixedLength="false" Unicode="true" />
+          <Property Type="Boolean" Name="Maximization" Nullable="false" />
+          <Property Type="String" Name="Weights" Nullable="false" MaxLength="Max" FixedLength="false" Unicode="false" />
+          <Property Type="String" Name="WeightsHash" Nullable="false" MaxLength="40" FixedLength="true" Unicode="false" />
+          <Property Type="String" Name="Distances" Nullable="false" MaxLength="Max" FixedLength="false" Unicode="false" />
+          <Property Type="String" Name="DistancesHash" Nullable="false" MaxLength="40" FixedLength="true" Unicode="false" />
+          <NavigationProperty Name="Solutions" Relationship="ProblemInstancesModel.FK_QAPSolution_QAPInstance1" FromRole="QAPInstance" ToRole="QAPSolution" />
+          <Property Type="Int32" Name="ProblemSize" Nullable="false" />
         </EntityType>
         <EntityType Name="QAPSolution">
           <Key>
-            <PropertyRef Name="id" />
+            <PropertyRef Name="Id" />
           </Key>
-          <Property Name="id" Type="Int32" Nullable="false" annotation:StoreGeneratedPattern="Identity" />
-          <Property Name="name" Type="String" Nullable="false" MaxLength="64" Unicode="true" FixedLength="false" />
-          <Property Name="assignment" Type="String" Nullable="false" MaxLength="Max" Unicode="false" FixedLength="false" />
-          <Property Name="assignment_sha1" Type="String" Nullable="false" MaxLength="40" Unicode="false" FixedLength="true" />
-          <Property Name="quality" Type="Double" Nullable="false" />
-          <NavigationProperty Name="QAPInstance" Relationship="ProblemInstancesModel.FK_QAPSolution_QAPInstance" FromRole="QAPSolution" ToRole="QAPInstance" />
+          <Property Type="Int32" Name="Id" Nullable="false" annotation:StoreGeneratedPattern="Identity" />
+          <Property Type="String" Name="Name" Nullable="false" MaxLength="64" FixedLength="false" Unicode="true" />
+          <Property Type="String" Name="Assignment" Nullable="false" MaxLength="Max" FixedLength="false" Unicode="false" />
+          <Property Type="String" Name="AssignmentHash" Nullable="false" MaxLength="40" FixedLength="true" Unicode="false" />
+          <Property Type="Double" Name="Quality" Nullable="false" />
+          <NavigationProperty Name="Instance" Relationship="ProblemInstancesModel.FK_QAPSolution_QAPInstance1" FromRole="QAPSolution" ToRole="QAPInstance" />
         </EntityType>
-        <Association Name="FK_QAPSolution_QAPInstance">
-          <End Role="QAPInstance" Type="ProblemInstancesModel.QAPInstance" Multiplicity="1">
-            <OnDelete Action="Cascade" />
-          </End>
-          <End Role="QAPSolution" Type="ProblemInstancesModel.QAPSolution" Multiplicity="*" />
+        <Association Name="FK_QAPSolution_QAPInstance1">
+          <End Type="ProblemInstancesModel.QAPInstance" Role="QAPInstance" Multiplicity="1" />
+          <End Type="ProblemInstancesModel.QAPSolution" Role="QAPSolution" Multiplicity="*" />
           <ReferentialConstraint>
             <Principal Role="QAPInstance">
-              <PropertyRef Name="name" />
+              <PropertyRef Name="Name" />
             </Principal>
             <Dependent Role="QAPSolution">
-              <PropertyRef Name="name" />
+              <PropertyRef Name="Name" />
             </Dependent>
           </ReferentialConstraint>
@@ -110,20 +107,20 @@
         <EntityContainerMapping StorageEntityContainer="ProblemInstancesModelStoreContainer" CdmEntityContainer="ProblemInstancesEntities">
           <EntitySetMapping Name="QAPInstances"><EntityTypeMapping TypeName="ProblemInstancesModel.QAPInstance"><MappingFragment StoreEntitySet="QAPInstance">
-            <ScalarProperty Name="name" ColumnName="name" />
-            <ScalarProperty Name="description" ColumnName="description" />
-            <ScalarProperty Name="maximization" ColumnName="maximization" />
-            <ScalarProperty Name="weights" ColumnName="weights" />
-            <ScalarProperty Name="weights_sha1" ColumnName="weights_sha1" />
-            <ScalarProperty Name="distances" ColumnName="distances" />
-            <ScalarProperty Name="distances_sha1" ColumnName="distances_sha1" />
-            <ScalarProperty Name="problemsize" ColumnName="problemsize" />
-          </MappingFragment></EntityTypeMapping></EntitySetMapping>
+            <ScalarProperty Name="ProblemSize" ColumnName="ProblemSize" />
+                <ScalarProperty Name="DistancesHash" ColumnName="DistancesHash" />
+                <ScalarProperty Name="Distances" ColumnName="Distances" />
+                <ScalarProperty Name="WeightsHash" ColumnName="WeightsHash" />
+                <ScalarProperty Name="Weights" ColumnName="Weights" />
+                <ScalarProperty Name="Maximization" ColumnName="Maximization" />
+                <ScalarProperty Name="Description" ColumnName="Description" />
+                <ScalarProperty Name="Name" ColumnName="Name" />
+              </MappingFragment></EntityTypeMapping></EntitySetMapping>
           <EntitySetMapping Name="QAPSolutions"><EntityTypeMapping TypeName="ProblemInstancesModel.QAPSolution"><MappingFragment StoreEntitySet="QAPSolution">
-            <ScalarProperty Name="id" ColumnName="id" />
-            <ScalarProperty Name="name" ColumnName="name" />
-            <ScalarProperty Name="assignment" ColumnName="assignment" />
-            <ScalarProperty Name="assignment_sha1" ColumnName="assignment_sha1" />
-            <ScalarProperty Name="quality" ColumnName="quality" />
-          </MappingFragment></EntityTypeMapping></EntitySetMapping>
+            <ScalarProperty Name="Quality" ColumnName="Quality" />
+                <ScalarProperty Name="AssignmentHash" ColumnName="AssignmentHash" />
+                <ScalarProperty Name="Assignment" ColumnName="Assignment" />
+                <ScalarProperty Name="Name" ColumnName="Name" />
+                <ScalarProperty Name="Id" ColumnName="Id" />
+              </MappingFragment></EntityTypeMapping></EntitySetMapping>
         </EntityContainerMapping>
       </Mapping>
@@ -148,6 +145,6 @@
       <Diagram Name="ProblemInstancesModel">
         <EntityTypeShape EntityType="ProblemInstancesModel.QAPInstance" Width="1.5" PointX="0.75" PointY="1" Height="2.7494921874999996" IsExpanded="true" />
-        <EntityTypeShape EntityType="ProblemInstancesModel.QAPSolution" Width="1.5" PointX="3" PointY="1.25" Height="2.1725878906249996" IsExpanded="true" />
-        <AssociationConnector Association="ProblemInstancesModel.FK_QAPSolution_QAPInstance" ManuallyRouted="false">
+        <EntityTypeShape EntityType="ProblemInstancesModel.QAPSolution" Width="1.5" PointX="3" PointY="1.25" Height="2.172587890625" IsExpanded="true" />
+        <AssociationConnector Association="ProblemInstancesModel.FK_QAPSolution_QAPInstance1" >
           <ConnectorPoint PointX="2.25" PointY="2.3362939453125" />
           <ConnectorPoint PointX="3" PointY="2.3362939453125" />
Index: /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/QAP/QAP.svc.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/QAP/QAP.svc.cs	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/QAP/QAP.svc.cs	(revision 6733)
@@ -26,5 +26,5 @@
     public string[] GetProblemInstances() {
       using (ProblemInstancesEntities context = new ProblemInstancesEntities()) {
-        return context.QAPInstances.Select(x => x.name).ToArray();
+        return context.QAPInstances.Select(x => x.Name).ToArray();
       }
     }
@@ -32,5 +32,5 @@
     public QAPInstanceDto GetProblemInstanceData(string instance) {
       using (ProblemInstancesEntities context = new ProblemInstancesEntities()) {
-        return new QAPInstanceDto(context.QAPInstances.Where(x => x.name == instance).Single());
+        return new QAPInstanceDto(context.QAPInstances.Where(x => x.Name == instance).Single());
       }
     }
@@ -38,11 +38,14 @@
     public QAPSolutionDto[] GetBestSolutionsData(string instance) {
       using (ProblemInstancesEntities context = new ProblemInstancesEntities()) {
-        QAPInstance qap = context.QAPInstances.Where(x => x.name == instance).SingleOrDefault();
+        QAPInstance qap = context.QAPInstances.Where(x => x.Name == instance).SingleOrDefault();
         if (qap == null) return new QAPSolutionDto[0];
+        context.LoadProperty<QAPInstance>(qap, x => x.Solutions);
         double best = double.NaN;
-        if (qap.maximization) best = qap.QAPSolutions.Max(x => x.quality);
-        else best = qap.QAPSolutions.Min(x => x.quality);
+        if (!qap.Solutions.Any()) return new QAPSolutionDto[0];
 
-        return qap.QAPSolutions.Where(x => x.quality == best).Select(x => new QAPSolutionDto(x)).ToArray();
+        if (qap.Maximization) best = qap.Solutions.Max(x => x.Quality);
+        else best = qap.Solutions.Min(x => x.Quality);
+
+        return qap.Solutions.Where(x => x.Quality == best).Select(x => new QAPSolutionDto(x)).ToArray();
       }
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/QAP/QAPInstanceDto.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/QAP/QAPInstanceDto.cs	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/QAP/QAPInstanceDto.cs	(revision 6733)
@@ -1,4 +1,3 @@
-﻿
-#region License Information
+﻿#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -22,4 +21,5 @@
 
 using System;
+using System.Linq;
 using System.Runtime.Serialization;
 
@@ -37,4 +37,8 @@
     [DataMember]
     public double[][] Distances { get; set; }
+    [DataMember]
+    public double BestKnownQuality { get; set; }
+    [DataMember]
+    public bool HasBestKnownQuality { get; set; }
 
     public QAPInstanceDto() {
@@ -43,12 +47,20 @@
 
     public QAPInstanceDto(QAPInstance qAPInstance) {
-      Name = qAPInstance.name;
-      Description = qAPInstance.description;
-      Maximization = qAPInstance.maximization;
+      Name = qAPInstance.Name;
+      Description = qAPInstance.Description;
+      Maximization = qAPInstance.Maximization;
       try {
-        Weights = PrimitiveSerializer.DeserializeDoubleMatrix(qAPInstance.weights);
-        Distances = PrimitiveSerializer.DeserializeDoubleMatrix(qAPInstance.distances);
+        Weights = SimpleSerializer.DeserializeDoubleMatrix(qAPInstance.Weights);
+        Distances = SimpleSerializer.DeserializeDoubleMatrix(qAPInstance.Distances);
       } catch (ArgumentException e) {
-        throw new PrimitiveSerializationException("Failed to deserialize the weights or distance matrix.", e);
+        throw new SimpleSerializationException("Failed to deserialize the weights or distance matrix.", e);
+      }
+      BestKnownQuality = double.NaN;
+      HasBestKnownQuality = false;
+      if (qAPInstance.Solutions.Any()) {
+        double bestQuality;
+        if (Maximization) bestQuality = qAPInstance.Solutions.Max(x => x.Quality);
+        else bestQuality = qAPInstance.Solutions.Min(x => x.Quality);
+        HasBestKnownQuality = true;
       }
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/QAP/QAPSolutionDto.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/QAP/QAPSolutionDto.cs	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/QAP/QAPSolutionDto.cs	(revision 6733)
@@ -1,4 +1,3 @@
-﻿
-#region License Information
+﻿#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -21,4 +20,5 @@
 #endregion
 
+using System;
 using System.Runtime.Serialization;
 
@@ -27,4 +27,6 @@
   public class QAPSolutionDto {
     [DataMember]
+    public bool AssignmentUndefined { get; set; }
+    [DataMember]
     public int[] Assignment { get; set; }
     [DataMember]
@@ -32,10 +34,12 @@
 
     public QAPSolutionDto() {
-
+      Quality = double.NaN;
     }
 
     public QAPSolutionDto(QAPSolution x) {
-      Assignment = PrimitiveSerializer.DeserializeIntArray(x.assignment);
-      Quality = x.quality;
+      AssignmentUndefined = String.IsNullOrEmpty(x.Assignment);
+      if (!AssignmentUndefined)
+        Assignment = SimpleSerializer.DeserializeIntArray(x.Assignment);
+      Quality = x.Quality;
     }
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/SimpleSerializationException.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/SimpleSerializationException.cs	(revision 6733)
+++ /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/SimpleSerializationException.cs	(revision 6733)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Services.ProblemInstances {
+  public class SimpleSerializationException : Exception {
+    public SimpleSerializationException() : base() { }
+    public SimpleSerializationException(string message) : base(message) { }
+    public SimpleSerializationException(string message, Exception innerException) : base(message, innerException) { }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/SimpleSerializer.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/SimpleSerializer.cs	(revision 6733)
+++ /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/SimpleSerializer.cs	(revision 6733)
@@ -0,0 +1,166 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Globalization;
+using System.Text;
+
+namespace HeuristicLab.Services.ProblemInstances {
+  public static class SimpleSerializer {
+    #region Double Matrix
+    public static string SerializeDoubleMatrix(double[][] matrix) {
+      StringBuilder builder = new StringBuilder();
+      int dim1 = matrix.Length;
+      int dim2 = matrix[0].Length;
+      builder.Append(dim1.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      builder.Append(";");
+      builder.Append(dim2.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      for (int i = 0; i < dim1; i++) {
+        for (int j = 0; j < dim2; j++) {
+          if (matrix[i].Length != dim2) throw new ArgumentException("ERROR jagged array is not a matrix!");
+          builder.Append(";" + matrix[i][j].ToString(CultureInfo.InvariantCulture.NumberFormat));
+        }
+      }
+      return builder.ToString();
+    }
+    public static string SerializeDoubleMatrix(double[,] matrix) {
+      StringBuilder builder = new StringBuilder();
+      int dim1 = matrix.GetLength(0);
+      int dim2 = matrix.GetLength(1);
+      builder.Append(dim1.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      builder.Append(";");
+      builder.Append(dim2.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      for (int i = 0; i < dim1; i++) {
+        for (int j = 0; j < dim2; j++) {
+          builder.Append(";" + matrix[i, j].ToString(CultureInfo.InvariantCulture.NumberFormat));
+        }
+      }
+      return builder.ToString();
+    }
+
+    public static double[][] DeserializeDoubleMatrix(string data) {
+      string[] tokens = data.Split(';');
+      int dim1 = int.Parse(tokens[0], CultureInfo.InvariantCulture.NumberFormat);
+      int dim2 = int.Parse(tokens[1], CultureInfo.InvariantCulture.NumberFormat);
+      if (tokens.Length != (dim1 * dim2) + 2) throw new SimpleSerializationException("ERROR: serialized data does not represent a matrix!");
+      double[][] result = new double[dim1][];
+      for (int i = 0; i < dim1; i++) {
+        result[i] = new double[dim2];
+        for (int j = 0; j < dim2; j++)
+          result[i][j] = double.Parse(tokens[i * dim1 + j + 2], CultureInfo.InvariantCulture.NumberFormat);
+      }
+      return result;
+    }
+    #endregion
+
+    #region Int Matrix
+    public static string SerializeIntMatrix(int[][] matrix) {
+      StringBuilder builder = new StringBuilder();
+      int dim1 = matrix.Length;
+      int dim2 = matrix[0].Length;
+      builder.Append(dim1.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      builder.Append(";");
+      builder.Append(dim2.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      for (int i = 0; i < dim1; i++) {
+        for (int j = 0; j < dim2; j++) {
+          if (matrix[i].Length != dim2) throw new ArgumentException("ERROR jagged array is not a matrix!");
+          builder.Append(";" + matrix[i][j].ToString(CultureInfo.InvariantCulture.NumberFormat));
+        }
+      }
+      return builder.ToString();
+    }
+    public static string SerializeIntMatrix(int[,] matrix) {
+      StringBuilder builder = new StringBuilder();
+      int dim1 = matrix.GetLength(0);
+      int dim2 = matrix.GetLength(1);
+      builder.Append(dim1.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      builder.Append(";");
+      builder.Append(dim2.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      for (int i = 0; i < dim1; i++) {
+        for (int j = 0; j < dim2; j++) {
+          builder.Append(";" + matrix[i, j].ToString(CultureInfo.InvariantCulture.NumberFormat));
+        }
+      }
+      return builder.ToString();
+    }
+
+    public static int[][] DeserializeIntMatrix(string data) {
+      string[] tokens = data.Split(';');
+      int dim1 = int.Parse(tokens[0], CultureInfo.InvariantCulture.NumberFormat);
+      int dim2 = int.Parse(tokens[1], CultureInfo.InvariantCulture.NumberFormat);
+      if (tokens.Length != (dim1 * dim2) + 2) throw new SimpleSerializationException("ERROR: serialized data does not represent a matrix!");
+      int[][] result = new int[dim1][];
+      for (int i = 0; i < dim1; i++) {
+        result[i] = new int[dim2];
+        for (int j = 0; j < dim2; j++)
+          result[i][j] = int.Parse(tokens[i * dim1 + j + 2], CultureInfo.InvariantCulture.NumberFormat);
+      }
+      return result;
+    }
+    #endregion
+
+    #region Double Array
+    public static string SerializeDoubleArray(double[] array) {
+      StringBuilder builder = new StringBuilder();
+      int dim1 = array.Length;
+      builder.Append(dim1.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      builder.Append(";");
+      for (int i = 0; i < dim1; i++) {
+        builder.Append(";" + array[i].ToString(CultureInfo.InvariantCulture.NumberFormat));
+      }
+      return builder.ToString();
+    }
+
+    public static double[] DeserializeDoubleArray(string array) {
+      string[] tokens = array.Split(';');
+      int dim1 = int.Parse(tokens[0], CultureInfo.InvariantCulture.NumberFormat);
+      double[] result = new double[dim1];
+      for (int i = 0; i < dim1; i++) {
+        result[i] = double.Parse(tokens[i + 1], CultureInfo.InvariantCulture.NumberFormat);
+      }
+      return result;
+    }
+    #endregion
+
+    #region Int Array
+    public static string SerializeIntArray(int[] array) {
+      StringBuilder builder = new StringBuilder();
+      int dim1 = array.Length;
+      builder.Append(dim1.ToString(CultureInfo.InvariantCulture.NumberFormat));
+      builder.Append(";");
+      for (int i = 0; i < dim1; i++) {
+        builder.Append(";" + array[i].ToString(CultureInfo.InvariantCulture.NumberFormat));
+      }
+      return builder.ToString();
+    }
+
+    public static int[] DeserializeIntArray(string array) {
+      string[] tokens = array.Split(';');
+      int dim1 = int.Parse(tokens[0], CultureInfo.InvariantCulture.NumberFormat);
+      int[] result = new int[dim1];
+      for (int i = 0; i < dim1; i++) {
+        result[i] = int.Parse(tokens[i + 1], CultureInfo.InvariantCulture.NumberFormat);
+      }
+      return result;
+    }
+    #endregion
+  }
+}
